#include "E.h"

void
MakeIcon(EWin * ewin)
{

  ActionClass        *ac;
  ImageClass         *ic;
  Action             *a;
  Button             *bt;
  char                s[25];
  char                can_embed_stuff = 0;

  sprintf(s, "%i", (int)ewin->client.win);
  ic = NULL;
  ac = FindItem("ICON", ewin->client.win, LIST_FINDBY_BOTH, LIST_TYPE_ACLASS);
  if (!ac)
    {
      ac = CreateAclass(s);
      a = CreateAction(1, 1, 0, 1, 0, 1, 0);
      AddItem(ac, "ICON", ewin->client.win, LIST_TYPE_ACLASS);
      AddAction(ac, a);
      AddToAction(a, ACTION_ICONIFY, duplicate(s));
      if (ewin->client.icon_name)
	ac->tooltipstring = duplicate(ewin->client.icon_name);
      else
	ac->tooltipstring = duplicate(ewin->client.title);
    }
  ic = MatchEwinByFunction(ewin, (void *(*)(EWin *, WindowMatch *))(MatchEwinIcon));

  if (!ic)
    {
      ic = FindItem("DEFAULT_ICON_BUTTON", 0, LIST_FINDBY_NAME,
		    LIST_TYPE_ICLASS);
      can_embed_stuff = 1;
    }
  bt = CreateButton(s, ic, ac, 0, 0, 10, 99999, 10, 99999, 0,
		    1023, 0, 0, 0, 1023, 0, 0, 0, 0, 1, 0, 1);

  if (mode.showicons)
    ShowButton(bt);
  FindEmptySpotForButton(bt, "ICON", mode.primaryicondir);
  AddItem(bt, "ICON", ewin->client.win, LIST_TYPE_BUTTON);

  if (can_embed_stuff)
    {
      if (ewin->client.icon_win)
	{
	  EmbedWindowIntoButton(bt, ewin->client.icon_win);
	  XMapWindow(disp, ewin->client.icon_win);
	}
      else if (ewin->client.icon_pmap)
	{
	  Window              PixmapWindow;
	  unsigned int        w, h;
	  int                 d;

	  GetWinWH(ewin->client.icon_pmap, &w, &h);
	  d = GetWinDepth(ewin->client.icon_pmap);
	  PixmapWindow = ECreateWindow(root.win, -100, -100, w, h, 0);

	  if (d == id->x.depth)
	    XSetWindowBackgroundPixmap(disp, PixmapWindow,
				       ewin->client.icon_pmap);
	  else
	    {
	      ImlibImage         *im;
	      Pixmap              pmap;

	      im = Imlib_create_image_from_drawable(id, ewin->client.icon_pmap,
						    0, 0, 0, w, h);
	      Imlib_render(id, im, w, h);
	      pmap = Imlib_move_image(id, im);
	      XSetWindowBackgroundPixmap(disp, PixmapWindow, pmap);
	      Imlib_free_pixmap(id, pmap);
	      Imlib_kill_image(id, im);
	    }
	  XShapeCombineMask(disp, PixmapWindow, ShapeBounding, 0, 0,
			    ewin->client.icon_mask, ShapeSet);
	  EmbedWindowIntoButton(bt, PixmapWindow);
	  XMapWindow(disp, PixmapWindow);
	  bt->destroy_inside_win = 1;
	}
    }
}

void
RemoveMiniIcon(EWin * ewin)
{

  Button             *bt = 0;
  ActionClass        *ac = 0;

  bt = FindItem("ICON", ewin->client.win, LIST_FINDBY_BOTH, LIST_TYPE_BUTTON);
  if (bt)
    {
      if (bt->inside_win)
	{
	  if (!bt->destroy_inside_win)
	    {
	      XReparentWindow(disp, bt->inside_win, root.win, 0, 0);
	      XUnmapWindow(disp, bt->inside_win);
	    }
	  bt->inside_win = 0;
	}
      DestroyButton(RemoveItem("ICON", ewin->client.win,
			       LIST_FINDBY_BOTH, LIST_TYPE_BUTTON));
    }
  ac = FindItem("ICON", ewin->client.win, LIST_FINDBY_ID,
		LIST_TYPE_ACLASS);
  if (ac)
    RemoveActionClass(RemoveItem("ICON", ewin->client.win,
				 LIST_FINDBY_ID, LIST_TYPE_ACLASS));

}
