#include "E.h"
#ifndef HAVE_SM
void
SessionInit(void)
{
}

void
ProcessICEMSGS(void)
{
}

int
GetSMfd(void)
{
  return -1;
}

void
SessionGetInfo(EWin * ewin)
{
  ewin = NULL;
}

void
SetSMID(char *smid)
{
  smid = NULL;
}

void
MatchEwinToSM(EWin * ewin)
{
  ewin = NULL;
}

#else /* HAVE_SM */
#include <X11/SM/SMlib.h>

typedef struct _match
  {
    char               *session_id;
    char               *name;
    char               *class;
    int                 x, y, w, h, desktop, iconified, shaded, sticky, layer;
  }
Match;

static char        *sm_client_id = NULL;
SmcConn             sm_conn = NULL;
int                 sm_fd = -1;
static int          num_match = 0;
Match              *matches = NULL;

static void         set_save_props(SmcConn smc_conn);
static void         callback_save_yourself2(SmcConn smc_conn, SmPointer client_data);
static void         callback_save_yourself(SmcConn smc_conn, SmPointer client_data,
			    int save_style, Bool shutdown, int interact_style,
					   Bool fast);
static void         callback_die(SmcConn smc_conn, SmPointer client_data);
static void         callback_save_complete(SmcConn smc_conn, SmPointer client_data);
static void         callback_shutdown_cancelled(SmcConn smc_conn, SmPointer client_data);

static void         SaveWindowStates(void);
static void         LoadWindowStates(void);

static void
set_save_props(SmcConn smc_conn)
{
  char               *user = NULL;
  char               *program = "Enlightenment";
  char                smid[] = "-smid";
  SmPropValue         programVal =
  {0, NULL};
  SmPropValue         userIDVal =
  {0, NULL};
  SmPropValue         restartVal[3] =
  {
    {0, NULL},
    {0, NULL},
    {0, NULL}};
  SmProp              programProp =
  {(char *)SmProgram, (char *)SmLISTofARRAY8, 1, &programVal};
  SmProp              userIDProp =
  {(char *)SmUserID, (char *)SmARRAY8, 1, &userIDVal};
  SmProp              restartProp =
  {(char *)SmRestartCommand, (char *)SmLISTofARRAY8, 3, (SmPropValue *) & restartVal};
  SmProp              cloneProp =
  {(char *)SmCloneCommand, (char *)SmLISTofARRAY8, 3, (SmPropValue *) & restartVal};
  SmProp             *props[] =
  {
    &programProp,
    &userIDProp,
    &restartProp,
    &cloneProp
  };

  user = username(getuid());
  userIDVal.length = strlen(user);
  userIDVal.value = user;
  programVal.length = strlen(program);
  programVal.value = program;
  restartVal[0].length = strlen(command);
  restartVal[0].value = command;
  restartVal[1].length = strlen(smid);
  restartVal[1].value = smid;
  restartVal[2].length = strlen(sm_client_id);
  restartVal[2].value = sm_client_id;
  SmcSetProperties(smc_conn, sizeof(props) / sizeof(props[0]), (SmProp **) & props);
  if (user)
    Efree(user);
}

static void
SaveWindowStates(void)
{
  EWin              **lst, *ewin;
  int                 i, num, x, y;
  FILE               *f;
  char                s[4096], *home;

  lst = (EWin **) ListItemType(&num, LIST_TYPE_EWIN);
  if (lst)
    {
      home = homedir(getuid());
      if (sm_client_id)
	Esnprintf(s, sizeof(s), "%s/.enlightenment/clients_save.%s", home, sm_client_id);
      else
	Esnprintf(s, sizeof(s), "%s/.enlightenment/clients_save", home);
      if (home)
	Efree(home);
      f = fopen(s, "w");
      if (f)
	{
	  for (i = 0; i < num; i++)
	    {
	      ewin = lst[i];
	      if (!(ewin->internal))
		{
		  if (ewin->session_id)
		    {
		      /* MUST have SESSION_ID to even try session manage it */
		      x = 0;
		      y = 0;
		      if (!ewin->sticky)
			{
			  x = desks.desk[ewin->desktop].current_area_x * root.w;
			  y = desks.desk[ewin->desktop].current_area_y * root.h;
			}
		      fprintf(f, "[CLIENT] %i %i %i %i %i %i %i %i %i\n",
			      ewin->x + x, ewin->y + y,
			      ewin->client.w, ewin->client.h,
			      ewin->desktop, ewin->iconified, ewin->shaded,
			      ewin->sticky, ewin->layer);
		      fprintf(f, "  [SESSION_ID] %s\n", ewin->session_id);
		      if (ewin->client.name)
			fprintf(f, "  [NAME] %s\n", ewin->client.name);
		      if (ewin->client.class)
			fprintf(f, "  [CLASS] %s\n", ewin->client.class);
		      if (ewin->client.command)
			fprintf(f, "  [COMMAND] %s\n", ewin->client.command);
		      if (ewin->client.title)
			fprintf(f, "  [TITLE] %s\n", ewin->client.title);
		    }
		}
	    }
	  fclose(f);
	}
      Efree(lst);
    }
}

static void
LoadWindowStates(void)
{
  FILE               *f;
  char                s[4096], s1[4096], *home;

  home = homedir(getuid());
  if (sm_client_id)
    Esnprintf(s, sizeof(s), "%s/.enlightenment/clients_save.%s", home, sm_client_id);
  else
    Esnprintf(s, sizeof(s), "%s/.enlightenment/clients_save", home);
  if (home)
    Efree(home);
  f = fopen(s, "r");
  if (f)
    {
      while (fgets(s, sizeof(s), f))
	{
	  sscanf(s, "%4000s", s1);
	  if (!strcmp(s1, "[CLIENT]"))
	    {
	      num_match++;
	      matches = Erealloc(matches, sizeof(Match) * num_match);
	      matches[num_match - 1].session_id = NULL;
	      matches[num_match - 1].name = NULL;
	      matches[num_match - 1].class = NULL;
	      sscanf(s, "%*s %i %i %i %i %i %i %i %i %i",
		     &(matches[num_match - 1].x),
		     &(matches[num_match - 1].y),
		     &(matches[num_match - 1].w),
		     &(matches[num_match - 1].h),
		     &(matches[num_match - 1].desktop),
		     &(matches[num_match - 1].iconified),
		     &(matches[num_match - 1].shaded),
		     &(matches[num_match - 1].sticky),
		     &(matches[num_match - 1].layer)
		);
	    }
	  else if (!strcmp(s1, "[SESSION_ID]"))
	    {
	      sscanf(s, "%*s %4000s", s1);
	      matches[num_match - 1].session_id = duplicate(s1);
	    }
	  else if (!strcmp(s1, "[NAME]"))
	    {
	      sscanf(s, "%*s %4000s", s1);
	      matches[num_match - 1].name = duplicate(s1);
	    }
	  else if (!strcmp(s1, "[CLASS]"))
	    {
	      sscanf(s, "%*s %4000s", s1);
	      matches[num_match - 1].class = duplicate(s1);
	    }

	}
      fclose(f);
    }
}

void
MatchEwinToSM(EWin * ewin)
{
  int                 i;
  char                match;

  if (!ewin->session_id)
    return;
  for (i = 0; i < num_match; i++)
    {
      if (!strcmp(ewin->session_id, matches[i].session_id))
	{
	  match = 1;

	  if ((ewin->client.name) && (matches[i].name) &&
	      (strcmp(ewin->client.name, matches[i].name)))
	    match = 0;
	  if ((ewin->client.class) && (matches[i].class) &&
	      (strcmp(ewin->client.class, matches[i].class)))
	    match = 0;
	  if (match)
	    {
	      ewin->client.already_placed = 1;
	      ewin->iconified = matches[i].iconified;
	      ewin->sticky = matches[i].sticky;
	      ewin->shaded = matches[i].shaded;
	      ewin->layer = matches[i].layer;
	      ewin->desktop = matches[i].desktop;
	      ewin->client.x = matches[i].x;
	      ewin->client.y = matches[i].y;
	      ewin->client.w = matches[i].w;
	      ewin->client.h = matches[i].h;
	      XResizeWindow(disp, ewin->client.win,
			    ewin->client.w, ewin->client.h);
	      return;
	    }
	}
    }
}

static void
callback_save_yourself2(SmcConn smc_conn, SmPointer client_data)
{
  set_save_props(smc_conn);
  /* Actually save the client window states here */
  SaveWindowStates();
  SmcSaveYourselfDone(smc_conn, True);
  client_data = NULL;
}

static void
callback_save_yourself(SmcConn smc_conn, SmPointer client_data,
		       int save_style, Bool shutdown, int interact_style,
		       Bool fast)
{
  SmcRequestSaveYourselfPhase2(smc_conn, callback_save_yourself2, NULL);
  client_data = NULL;
  save_style = 0;
  shutdown = False;
  interact_style = 0;
  fast = False;
}

static void
callback_die(SmcConn smc_conn, SmPointer client_data)
{
  char                sss[FILEPATH_LEN_MAX];

  if (smc_conn == sm_conn)
    {
      sm_conn = NULL;
      sm_fd = -1;
    }
  SetEInfoOnAll();
  UngrabX();
  UnGrabTheButtons();
  XCloseDisplay(disp);
  if (mode.autosave)
    SaveUserControlConfig();
  else
    DeleteUserControlConfig();
  if (mustdel)
    {
      Esnprintf(sss, sizeof(sss), "/bin/rm -rf %s", themepath);
      system(sss);
    }
  ApplySclass(FindItem("SOUND_EXIT", 0,
		       LIST_FINDBY_NAME, LIST_TYPE_SCLASS));
  SmcCloseConnection(smc_conn, 0, NULL);
  EExit(0);
  client_data = NULL;
}

static void
callback_save_complete(SmcConn smc_conn, SmPointer client_data)
{
  smc_conn = NULL;
  client_data = NULL;
}

static void
callback_shutdown_cancelled(SmcConn smc_conn, SmPointer client_data)
{
  SmcSaveYourselfDone(smc_conn, False);
  client_data = NULL;
}

void
SessionInit(void)
{
  static SmPointer    context;
  SmcCallbacks        callbacks;
  char               *client_id = NULL;

  callbacks.save_yourself.callback = callback_save_yourself;
  callbacks.die.callback = callback_die;
  callbacks.save_complete.callback = callback_save_complete;
  callbacks.shutdown_cancelled.callback = callback_shutdown_cancelled;

  callbacks.save_yourself.client_data =
    callbacks.die.client_data =
    callbacks.save_complete.client_data =
    callbacks.shutdown_cancelled.client_data = (SmPointer) NULL;
  if (getenv("SESSION_MANAGER"))
    {
      char                error_string_ret[4096] = "";

      sm_conn = SmcOpenConnection(NULL, &context, SmProtoMajor, SmProtoMinor,
				  SmcSaveYourselfProcMask | SmcDieProcMask |
				  SmcSaveCompleteProcMask |
				  SmcShutdownCancelledProcMask,
				  &callbacks, sm_client_id, &client_id,
				  4096, error_string_ret);
      if (error_string_ret[0])
	fprintf(stderr, "While connecting to session manager:\n%s.",
		error_string_ret);
    }
  if (sm_conn)
    {
      IceConn             ice_conn;
      int                 restarted = 0;

      if (sm_client_id == NULL)
	sm_client_id = client_id;
      else if (!strcmp(sm_client_id, client_id) != 0)
	{
	  free(sm_client_id);
	  sm_client_id = client_id;
	}
      else
	{
	  free(client_id);
	  restarted = 1;
	}
      ice_conn = SmcGetIceConnection(sm_conn);
      sm_fd = IceConnectionNumber(ice_conn);
    }
  LoadWindowStates();
}

void
ProcessICEMSGS(void)
{
  IceProcessMessagesStatus status;

  status = IceProcessMessages(SmcGetIceConnection(sm_conn), NULL, NULL);
  if (status == IceProcessMessagesIOError)
    {
      Alert("ERROR!\n"
	    "Lost the Session Manager that was there?\n"
	    "Here here session manager... come here... want a bone?\n"
	 "Oh come now! Stop sulking! Bugger. Oh well. Will continue without\n"
	    "a session manager.\n"
	    "I'll survive somehow.\n");
      sm_conn = NULL;
      sm_fd = -1;
    }
}

int
GetSMfd(void)
{
  return sm_fd;
}

void
SessionGetInfo(EWin * ewin)
{
  Atom                a;
  char               *s;
  int                 size;

  if (ewin->session_id)
    {
      Efree(ewin->session_id);
      ewin->session_id = NULL;
    }
  a = XInternAtom(disp, "SM_CLIENT_ID", False);
  s = AtomGet(ewin->client.win, a, XA_STRING, &size);
  if (s)
    {
      ewin->session_id = Emalloc(size + 1);
      memcpy(ewin->session_id, s, size);
      ewin->session_id[size] = 0;
      Efree(s);
      return;
    }
  s = AtomGet(ewin->client.group, a, XA_STRING, &size);
  if (s)
    {
      ewin->session_id = Emalloc(size + 1);
      memcpy(ewin->session_id, s, size);
      ewin->session_id[size] = 0;
      Efree(s);
      return;
    }
}

void
SetSMID(char *smid)
{
  if (sm_client_id)
    Efree(sm_client_id);
  sm_client_id = NULL;
  sm_client_id = duplicate(smid);
}
#endif /* HAVE_SM */
